package at.jku.ssw.textsearch;

import at.jku.ssw.list.List;

/** A searcher for patterns in a string. */
public abstract class TextSearcher {

	/**
	 * Returns a list of all start positions where the <code>pattern</code>
	 * occurs in the <code>text</code>.
	 * 
	 * <ul>
	 * <li>If <code>matchCase</code> is true, matching is done case sensitive.
	 * <li>If <code>wholeWordOnly</code> is true, a match counts only if the
	 * pattern is found as a whole word, otherwise matches inside of words also
	 * count.
	 * </ul>
	 * 
	 * @return a {@link List} of <code>int</code>.
	 * @throws IllegalArgumentException
	 *             if the pattern is empty.
	 */
	public abstract List findMatches(String text, String pattern, boolean matchCase, boolean wholeWordOnly);
}
